# Configuration file for the Sphinx documentation builder.
#
# This file only contains a selection of the most common options. For a full
# list see the documentation:
# https://www.sphinx-doc.org/en/master/usage/configuration.html

# -- Path setup --------------------------------------------------------------

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#
import os
import sys
import sphinx_rtd_theme
sys.path.insert(0, os.path.abspath('../..'))


# -- Project information -----------------------------------------------------

project = 'optimeed'
copyright = '2020, De Gréef Christophe'
author = 'De Gréef Christophe'

# The full version, including alpha/beta/rc tags
release = '1.1.2'


# -- General configuration ---------------------------------------------------
autoclass_content = 'both'
add_module_names = False

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = [
    'sphinx.ext.autodoc',
    'sphinx.ext.viewcode',
    'sphinx.ext.inheritance_diagram',
    'autoapi.extension'  # https://sphinx-autoapi.readthedocs.io/en/latest/
]

# Add any paths that contain templates here, relative to this directory.
templates_path = ['_templates']

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This pattern also affects html_static_path and html_extra_path.
exclude_patterns = ['*/pyqtgraph/*', '*/ansi2html/*', '*/platypus/*']

# autoapi_modules = {'optimeed': {'template': 'myTemplate', 'output': 'API'}}

autoapi_dirs = ['../../optimeed']
autoapi_ignore = ['*/pyqtgraph/*', "*/platypus/*"]
autoapi_keep_files = True
autoapi_root = 'API'
autoapi_add_toctree_entry = False

# -- Options for HTML output -------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
html_theme = 'sphinx_rtd_theme'
master_doc = 'index'

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".

# html_static_path = ['_static']
# html_theme_path = [sphinx_rtd_theme.get_html_theme_path()]

